;----------------------
;-------------definitions-----------------
cs81	bit  p1.7
cs82	bit  p3.0
a0	bit  p3.4
a1	bit  p3.5
;wr	bit  p3.6
;rd	bit  p3.7
DA0             BIT P1.0
DA1             BIT P1.1
DA2             BIT P1.2
CS0             BIT P1.3
CS1             BIT P1.4
DIOR            BIT P1.5
DIOW            BIT P1.6
IORDY           BIT P3.1
INTRQ           BIT P3.2
RESETS           BIT P3.3


DDL             EQU 	P0
StartOfT	equ	35h

DatabusL        EQU 	020H
DatabusH        EQU 	021H
Byte_Count      EQU 	022H

Audio_Status    EQU 	023H      ;Sub-Q Channel Current Audio Status
Track           EQU 	024H      ;Current Track Number
Total_Tracks    EQU 	025H      ;Track to scan to
Button_State    EQU 	026H      ;Last state of the buttons
Button_State1   EQU 	027H
M_Field         EQU 	028H    	;Minute Field
S_Field         EQU 	029H    	;Second Field
F_Field         EQU 	02aH    	;Frame Field
TOC_Length      EQU 	02bH    	;TOC data length in bytes
First_Track     EQU 	02cH   		;First track number on CD
Last_Track      EQU 	02dH    	;Last track number on CD
Digit1		equ  	02eh
Digit2		equ  	02fh
dj		equ  	030h	
RestoreCnt1	equ	031h
RestoreCnt2	equ	032h
RestoreCnt3	equ	033h


SegTab	equ  0f00h
ENTERB	equ  0f0h
PLAYB	equ  0f1h
STOPB	equ  0f2h
PAUSEB	equ  0f3h
FWDB	equ  0f4h
REWB	equ  0f5h
;------------------------------------------
;------------------Main--------------------
org	0
Main:
	acall	Init
	acall	Init82551
	acall	Init82552
	;acall	delay
	;acall	delay
	;acall	doplay;///test
	;//////////////////


	GetNextKey:
	acall	GetKey
	
	mov	r0,a
	anl	a,#0f0h
	cjne	a,#0f0h,Isnum
	mov	a,r0

	;//////  
	;acall    Sub_Channel 	
	;acall	delay
	;acall	delay
	;acall	delay
	;acall	delay
	cjne	a,#PLAYB,over4
	acall	DoPlay
	sjmp	GetNextKey
	;//////  
	over4:
	cjne	a,#PAUSEB,over5
	acall	DoPause
	sjmp	GetNextKey
	;//////  
	over5:
	cjne	a,#FWDB,over6
	acall	DoFwd
	sjmp	GetNextKey
	;/////
	over6:
	cjne	a,#REWB,over7
	acall	DoRew
	sjmp	GetNextKey
	;//////
	over7:
	cjne	a,#STOPB,over8
	acall	DoStop
	sjmp	GetNextKey
	;//////
	over8:
	cjne	a,#ENTERB,GetNextKey
	
	acall	DoEnter
	
	sjmp	GetNextKey
	;/////////////////////the key is a number////////////////
	Isnum:
		mov	a,#Digit1
		add	a,dj
		mov	r1,a
		mov	a,r0
		mov	@r1,a
		;//////dispaly the number//////
		mov	a,Dj
		cjne	a,#1,First
		clr	a
		mov	dj,a
		acall	Write_Digit2
		sjmp	GetNextKey
		First:
		inc	a
		mov	dj,a
		acall	Write_Digit1
		sjmp	GetNextKey
	
	
	










;------------------RestoreDigit-------------
RestoreDigit:
	mov	a,RestoreCnt1
	cjne	a,#0ffh,inc1
	mov	RestoreCnt1,#000h
	mov	a,RestoreCnt2
	cjne	a,#0ffh,inc2
	mov	RestoreCnt2,#000h
	mov	a,RestoreCnt3
	cjne	a,#01h,inc3
	mov	RestoreCnt3,#000h
	;-----------------------
	;acall	sub_channel
	mov	a,track
	mov	b,#10
	div	ab
	mov	Digit1,a;
	mov	Digit2,b;
	acall	Write_Digit1	
	acall	Write_Digit2
	mov	dj,#0
	sjmp	EndRestore
	
	inc1:
		inc	RestoreCnt1
		sjmp	EndRestore
	inc2:
		inc	RestoreCnt2
		sjmp	EndRestore
	inc3:
		inc	RestoreCnt3
		sjmp	EndRestore

	



	EndRestore:
	ret
;--------------------------------------------		
;-----------------InitCounter----------------
InitCounter:
	mov	RestoreCnt1,#00h
	mov	RestoreCnt2,#00h
	mov	RestoreCnt3,#00h
	ret
	
;--------------------------------------------
;--------------------------------------------		
Init:
	setb	cs82
	clr	cs81
	MOV     P1,#000H     	;Set Port 1 to zero (needs to be low for internal pull-up for pause)
	setb	p3.1
	setb	p3.2
	setb	p3.3
	SETB    DIOR
	SETB    DIOW
	acall	ResetCD
	acall	start_unit
	setb	wr
	setb	rd
	mov	Dj,#0
	mov	track,#0
	acall	InitCounter
	ret
;------------------------------------------------
;-----------------------ResetCD------------------
ResetCD:
Hard_Reset:
	acall	Delay
	CLR     RESETS           ;Assert Reset-
	acall    DELAY
	acall    DELAY
	SETB    RESETS           ;Negate Reset-  
	acall    DELAY
	acall    DELAY
Soft_Reset:
	acall    Set_Status  
	acall    Read
	MOV     A,DatabusL
	ANL     A,#10001000B
	JNZ     Soft_Reset      ;Wait for BSY=0, DRQ=0

	mov	digit2,#1;////test
	acall	Write_Digit2;///test

	acall    Set_Command
	MOV     DDL,#008h       ;Soft Reset

	mov	a,#000h		;MOV     DDH,#000h
	acall	WritePortA	;	
	
	acall    Write
	acall    DELAY
	RET    


;------------------------------------------------
;----------------------DoPlay--------------------
DoPlay:
	;acall    Read_TOC
	MOV	a,digit1
	mov	b,#10
	mul	ab
	add	a,digit2

	MOV     M_Field,a
	MOV     S_Field,#002H
	MOV     F_Field,#000H
	acall    Play
	ret
;------------------------------------------------
;----------------------DoEnter--------------------
DoEnter:
	acall    Read_TOC
	ret
;------------------------------------------------
;----------------------DoPause--------------------
DoPause:
	;acall	Send_Packet;///test
	acall	sub_channel
	acall	pause

	ret
;------------------------------------------------
;----------------------DoStop--------------------
DoStop:
	acall	stop_play
	ret
;------------------------------------------------
;----------------------DoFwd--------------------
DoFwd:
	acall    Sub_Channel 	
	ret
;------------------------------------------------
;----------------------DoTRew--------------------
DoRew:
	ret
;------------------------------------------------
;------------------------GetKey--------------------------
GetKey:
	mov	a,#0h
	acall	WritePortCL
	
	keyon:
	acall	ReadPortCH
	cjne	A,#0fh,keyon
	

	nokey:
	acall	ReadPortCH
	cjne	A,#0fh,over1
	acall	RestoreDigit
	sjmp	nokey
	over1:
	
	
	acall	SDELAY
	
	acall	ReadPortCH
	cjne	a,#0fh,over2
	sjmp	keyon
	over2:

	acall	InitCounter	

	;//////
	mov	a,#0eh
	acall	WritePortCL
	acall 	ReadPortCH
	cjne	a,#0fh,row_0
	;//////
	mov	a,#0dh
	acall	WritePortCL
	acall 	ReadPortCH
	cjne	a,#0fh,row_1
	;//////
	mov	a,#0bh
	acall	WritePortCL 
	acall 	ReadPortCH
	cjne	a,#0fh,row_2
	;//////
	mov	a,#07h
	acall	WritePortCL
	acall 	ReadPortCH
	cjne	a,#0fh,row_3
	ljmp	GetKey
	row_0:
		Mov	Dptr,#KCODE0
		sjmp	Find
	row_1:
		Mov	Dptr,#KCODE1
		sjmp	Find
	row_2:
		Mov	Dptr,#KCODE2
		sjmp	Find
	row_3:
		Mov	Dptr,#KCODE3
		sjmp	Find
	Find:
	rrc	a
	jnc	Match
	inc	Dptr
	sjmp	Find
	Match:
	mov	a,#0
	movc	A,@A+Dptr
	ret
	

;--------------------Init82551----------------

Init82551: ;first 8255: PA=out PB=out PCH=in PCL=out 
	  ;secon 8255: PA=out PB=out PCH=out PCL=out
	setb	cs82
	clr	cs81
	mov	p2,#10001000B;*********
	setb	a0
	setb	a1
	clr	wr
	nop
	nop
	setb	wr
	ret
;---------------------------------------------------
;-----------------------Init82552--------------------
Init82552:
	setb	cs81
	clr	cs82
	mov	p2,#10000000B;*********
	setb	a0
	setb	a1
	clr	wr
	nop
	nop
	setb	wr
	setb	cs82
	clr	cs81
	ret
;----------------------------------------------
;-------------------In82552---------------------
In82552: ;second 8255: PA=in PB=out PCH=out PCL=out
	setb	cs81
	clr	cs82
	mov	p2,#10010000B;**********
	setb	a0
	setb	a1
	clr	wr
	nop
	nop
	setb	wr
	setb	cs82
	clr	cs81
	ret
;-----------------------------------------------
;--------------------WritePortB-----------------
WritePortB:
	mov	p2,A
	setb	a0
	clr	a1
	clr	wr
	nop
	nop
	setb	wr
	ret
;-----------------------------------------------
;--------------------WritePortCL----------------
WritePortCL:
	mov	p2,A
	setb	a1
	clr	a0
	clr	wr
	nop
	nop
	setb	wr
	ret
;-----------------------------------------------
;------------------------WritePortC2----------------------
WritePortC2:
	setb	cs81
	clr	cs82
	clr	a0
	setb	a1
	mov	p2,a
	clr	wr
	nop
	nop
	setb	wr
	setb	cs82
	clr	cs81
	ret	
;---------------------------------------------------------
;---------------------ReadPortCH---------------------
ReadPortCH:
	mov	p2,#0FFh
	setb	a1
	clr	a0
	clr	rd
	nop
	nop
	mov	a,p2
	setb	rd
	anl	a,#0f0h
	swap	a
	ret
;-----------------------------------------------------
;----------------------ReadPortA----------------------
ReadPortA: ;read from second 8255's PA
	acall	In82552
	setb	cs81
	setb	cs82
	mov	p2,#0FFh
	clr 	cs82
	clr	a0
	clr	a1
	clr	rd
	nop
	nop
	mov	a,p2
	setb	rd
	setb	cs82
	clr	cs81
	acall	Init82552
	ret
;-------------------------------------------------------
;------------------------WritePortA---------------------
WritePortA:
	setb	cs81
	clr	cs82
	mov	p2,a
	clr	a0
	clr	a1
	clr	wr
	nop
	nop
	setb	wr
	setb	cs82
	clr	cs81 
	ret
;-------------------------------------------------------
;------------------------WritePortA1---------------------
WritePortA1:
	mov	p2,a
	clr	a0
	clr	a1
	clr	wr
	nop
	nop
	setb	wr
	ret
;-------------------------------------------------------
;------------------------Write_Digit1--------------------
Write_Digit1:
	mov	Dptr,#SegTAb
	;mov	DPL,#00h
	mov	a,Digit1
	movc	a,@a+dptr
	call	WritePortA1
	ret
;-------------------------------------------------------
;------------------------Write_Digit2--------------------
Write_Digit2:
	mov	DPtr,#SegTab
	;mov	DPL,#00h
	mov	a,Digit2
	movc	a,@a+dptr
	acall	WritePortB
	ret
;--------------------------------------------------------





;=============================================================================
;           Send Packet Command (ATA)
;=============================================================================
Send_Packet:
	acall    Set_Status  
	acall    Read
	MOV     A,DatabusL
	ANL     A,#010001000B
	JNZ     Send_Packet         ;Wait for BSY=0, DRQ=0

	acall    Set_DriveSelect
	MOV     DDL,#10100000B     ;Select Drive 0, LBA;/////changed
	
	mov	a,#000h		;MOV     DDH,#000h
	acall	WritePortA	;	

	acall    Write        
	acall    Set_ByteCountLow
	MOV     DDL,#0ffh           ;////changed Maximum 255!!!!!       
	acall    Write
	acall    Set_ByteCountHigh
	MOV     DDL,#0ffh		 ;/////changed Maximum 255!!!!!  
	acall    Write

	acall    Set_Feature
	acall    Write
	acall    Set_Command
	MOV     DDL,#0A0H               ;ATAPI Packet Command
	acall    Write
Wait_DRQ:
	acall    Set_Status      
	acall    Read
	MOV     A,DatabusL
	ANL     A,#010001000B
	CJNE    A,#000001000B,Wait_DRQ  ;Poll for DRQ=1,BSY=0
	RET

;=============================================================================
;           Start_Unit Packet
;=============================================================================
Start_Unit:
	acall    Send_Packet
	acall    Set_Data
	MOV     DDL,#01BH       ;Operation Code
	mov	a,#00h		;MOV     DDH,#000H       
	acall	WritePortA	;Reserved, Bit0,Immed = 0	
	acall    Write
	
	MOV     DDL,#000H       ;Reserved
	acall    Write
	MOV     DDL,#001H       ;Reserved, Bit1,LoEj = 0, Bit0,Start = 1
	mov	a,#00h		;MOV     DDH,#000H       ;Reserved
	acall	WritePortA
	
	acall    Write
	mov 	DDL, #0;/////ADDED
	mov	a,#00h		;MOV     DDH,#000H       ;Reserved
	acall	WritePortA	;
	
	acall    Write
	acall    Write
	acall    Write
	acall    Wait_INTRQ
	RET

;=============================================================================
;           Stop Play Packet
;=============================================================================
Stop_Play:
	acall    Send_Packet
	acall    Set_Data
	MOV     DDL,#04EH       ;Operation Code
	mov	a,#000h		;
	acall	WritePortA	;MOV     DDH,#000H       ;Reserved	
	
	acall    Write
	MOV     DDL,#000H       ;Reserved
	acall    Write
	acall    Write
	acall    Write
	acall    Write
	acall    Write
	acall    Wait_INTRQ
	RET

;=============================================================================
;           Play Packet
;=============================================================================
Play:   
	acall    Send_Packet
	acall    Set_Data
	MOV     DDL,#047H       ;Play Audio MSF Command
	mov	a,#0h
	acall	WritePortA
				;MOV     DDH,#000H       ;Resered
	acall    Write
	MOV     DDL,#000H       ;Resered
	MOV     A,M_Field
	acall	WritePortA
				;MOV     DDH,A           ;Starting M Field
	acall    Write
	MOV     A,S_Field
	MOV     DDL,A           ;Starting S Field
	MOV     A,F_Field
	acall	WritePortA
				;MOV     DDH,A           ;Starting F Field
	acall    Write
	MOV     DDL,#063H       ;Ending M Field  
	mov	a,#03Bh
	acall	WritePortA
				;MOV     DDH,#03BH       ;Ending S Field
	acall    Write
	MOV     DDL,#04AH       ;Ending F Field
	mov	a,#00h
	acall	WritePortA
				;MOV     DDH,#000H       ;Reserved
	acall    Write
	MOV     DDL,#000H       ;Reserved
	acall    Write
	acall    Wait_INTRQ       
	RET
;=============================================================================
;           Pause/Resume Packet
;=============================================================================
Pause:  
	acall    Send_Packet 
	acall    Set_Data
	MOV     DDL,#04BH       ;Pause/Resume Command
	mov	a,#00h
	acall	WritePortA
				;MOV     DDH,#000H       ;Resered
	acall    Write
	MOV     DDL,#000H       ;Resered
	acall    Write
	acall    Write
	acall    Write
	;Check if already paused
	MOV     DDL,#000H       ;Reserved, Resume Bit(0) (Pause if playing)
	MOV     A,Audio_Status
	CJNE    A,#012H,Paused
	MOV     DDL,#001H       ;Resume if Paused
Paused:     
	mov	a,#00h
	acall	WritePortA
				;MOV     DDH,#000H       ;Reserved
	acall    Write
	MOV     DDL,#000H       ;Reserved
	acall    Write
	acall    Wait_INTRQ       
	RET

;=============================================================================
;           Read Sub-Channel Packet
;=============================================================================
Sub_Channel:    
	acall    Send_Packet
	acall    Set_Data
	MOV     DDL,#042H       ;Read Sub-Channel Command
	mov	a,#002h
	acall	WritePortA
	acall    Write		;MOV     DDH,#002H       ;Resered, Bit1=MSF, Bit0=Reserved
	
	MOV     DDL,#040H       ;Resered, Bit6=SubQ, Reserved
	mov	a,#001h
	acall	WritePortA
				;MOV     DDH,#001H       ;Sub-cahnnel Data Format (CD-ROM current position)
	acall    Write
	
	MOV     DDL,#000H       ;Reserved
	mov	a,#000h
	acall	WritePortA
				;MOV     DDH,#000H       ;Reserved
	acall    Write
	MOV     DDL,#000H       ;Track number (Must be zero - Not relevant)
	mov	a,#000h
	acall	WritePortA
				;MOV     DDH,#000H       ;Allocation Length (MSB) (!!!!!! I think zero!)
	acall    Write
	MOV     DDL,#0ffH;////changed       ;Allocation Length (LSB) (!!!!!! I think ONE!)
	mov	a,#000h
	acall	WritePortA
				;MOV     DDH,#000H       ;Reserved
	acall    Write
	MOV     DDL,#000H       ;Reserved
	mov	a,#000h
	acall	WritePortA
				;MOV     DDH,#000H       ;Reserved
	acall   Write
	;mov	digit2, #2;////test
	;acall	Write_Digit2;////test
	acall    Wait_INTRQ   

	;mov	digit2, #3;/////test
	;acall	Write_Digit2;/////test
	acall    Read_Channel_Data   

	;mov	digit2, #4;////test
	;acall	Write_Digit2;////test

	mov 	a, Track;///test
	;mov 	digit2, a;////test
	;acall	Write_Digit2;////test

	RET

;=============================================================================
;                   Read TOC Packet
;=============================================================================
Read_TOC:    
	acall    Send_Packet
	acall    Set_Data
	MOV     DDL,#043H       ;Read Sub-Channel Command
	mov	a,#002h
	acall	WritePortA
				;MOV     DDH,#002H       ;Resered, Bit1=MSF, Bit0=Reserved
	acall    Write
	MOV     DDL,#000H       ;Reserved, Format
	mov	a,#000h
	acall	WritePortA
				;MOV     DDH,#000H       ;Reserved
	acall    Write
	MOV     DDL,#000H       ;Reserved
	mov	a,#000h
	acall	WritePortA
				;MOV     DDH,#000H       ;Reserved
	acall    Write
	MOV     DDL,#000H       ;Starting Track
	mov	a,#000h
	acall	WritePortA
				;MOV     DDH,#000H       ;Allocation Length (MSB) 
	acall    Write
	MOV     DDL,#001H       ;Allocation Length (LSB) 
	mov	a,#000h
	acall	WritePortA
				;MOV     DDH,#000H       ;Format, Reserved
	acall    Write
	MOV     DDL,#000H       ;Reserved
	mov	a,#000h
	acall	WritePortA
				;MOV     DDH,#000H       ;Reserved
	acall    Write

	mov	digit2, #1;////test
	acall	Write_Digit2;////test

	acall    Wait_INTRQ   

	mov 	digit2, #2;/////test
	acall	Write_Digit2;///test

	acall    Read_TOC_Data   
	RET

;=============================================================================
;           Wait for INTRQ=1 Pending Command Packet
;=============================================================================
Wait_INTRQ:        
	MOV     A,P3
	ANL     A,#000000100B
	JZ      Wait_INTRQ
	acall    Set_Status
	acall    Read
	acall    Set_CauseOfInt      ;To clear the interupt for Data In
	acall    Read 
	RET

;=============================================================================
;           Read in Sub Q Data
;=============================================================================
Read_Channel_Data:
	;Wait for DRQ=1
	;acall	Set_Error;////test
	;acall	Read;///test
	;mov	a, DataBusL;///test
	;mov 	digit2, a;///test
	;acall	Write_Digit2;///test
	acall    Set_Status
	acall    Read
	MOV     A,DatabusL
	ANL     A,#00001000B   ;Wait DRQ=1
	JZ      Read_Channel_Data

	;mov 	digit2, #6;///test
	;acall	Write_Digit2;////test

	acall    Set_Data
	acall    Read
	MOV     A,DatabusH       ;Bit 1
	MOV     Audio_Status,A
	acall    Read
	acall    Read
	acall    Read
	MOV     A,DatabusL       ;Bit 6
	MOV     Track,A
	acall    Read
	acall    Read
	acall    Read
	acall    Read

	;Should be a DRQ=0 NOW
	acall    Set_Status
	acall    Read

	;mov	digit2, #7
	;acall	Write_Digit2

	RET

;=============================================================================
;           Read in TOC Data
;=============================================================================
Read_TOC_Data:  
	;Wait for DRQ=1
	acall    Set_Status

	acall    Read
	mov	digit2, #3
	acall	Write_Digit2	

	MOV     A,DatabusL
	ANL     A,#000001000B   ;Wait DRQ=1
	JZ      Read_TOC_Data

	acall    Set_Data
	acall    Read
	MOV     A,DatabusH       ;Bit 1
	MOV     TOC_Length,A    ;LIMITATION - Only reads ONE byte of the length!
				;              IE Less that 255 bytes 36 Tracks MAX 
	acall    Read
	MOV     A,DatabusL
	MOV     First_Track,A
	MOV     A,DatabusH
	MOV     Last_Track,A
	DEC     TOC_Length
	DEC     TOC_Length

	;ALLOCATE THE FIRST PORTION OF MEMORY HERE
	;MOV     DPH,#000H   ;
	MOV     r1,#StartOfT   ;Last 256 Bytes of memory

Next_Descriptor:
	acall    Read
	acall    Read    
	acall    Read
	;M Field
	;MOV     A,DPL
	;INC	A
	;MOV	DPL,A
	inc	r1
	MOV     A,DatabusH
	MOV	@r1,A
	acall    Read
	;S Field
	;MOV     A,DPL
	;INC	A
	;MOV	DPL,A
	inc	r1
	MOV     A,DatabusL
	MOV	@r1,A 
	;F Field
	;MOV     A,DPL
	;INC	A
	;MOV	DPL,A
	inc	r1
	MOV     A,DatabusH
	MOV	@r1,A 
	DEC     TOC_Length
	DEC     TOC_Length
	DEC     TOC_Length
	DEC     TOC_Length
	DEC     TOC_Length
	DEC     TOC_Length
	DEC     TOC_Length
	DEC     TOC_Length
	MOV     A,TOC_Length
	INC	Total_Tracks
	JNZ     Next_Descriptor
	;Should be a DRQ=0 NOW

TOC_DRQ_Wait:    
	acall    Set_Status      
	acall    Read
	MOV     A,DatabusL
	ANL     A,#000001000B
	CJNE    A,#000000000B,TOC_DRQ_Wait  ;Poll for DRQ=0
	
	RET

;=============================================================================
;               Set Addresses
;=============================================================================
Set_Feature:		clr 	cs0
			setb	cs1
			clr	da2
			clr	da1
			setb	da0
			ret

						
Set_CauseOfInt:   	clr     CS0     
			setb    CS1    
			CLR     DA2     
			SETB    DA1    
			CLR     DA0    
			RET

Set_ByteCountLow: 	clr     CS0
			setb    CS1
			SETB    DA2
			CLR     DA1
			CLR     DA0
			RET

Set_ByteCountHigh:	clr     CS0
			setb    CS1
			SETB    DA2
			CLR     DA1
			SETB    DA0
			RET

Set_DriveSelect:  	clr     CS0     
			setb    CS1     
			SETB    DA2     
			SETB    DA1     
			CLR     DA0     
			RET

Set_Command: 
Set_Status:       	clr     CS0   
			setb    CS1    
			SETB    DA2     
			SETB    DA1    
			SETB    DA0    
			RET

Set_Data:         	clr     CS0
			setb    CS1
			CLR     DA2
			CLR     DA1
			CLR     DA0
			RET

Set_Error:	clr	CS0
		Setb	cs1
		clr	DA2
		clr	DA1
		setb	DA0
		ret

;=============================================================================
;                   Read Databus
;=============================================================================
Read:       MOV     DDL,#0FFH       ;Port0 Pull-ups
		CLR     DIOR            ;Assert DIOR
		MOV     A,DDL
		MOV     DatabusL,A
		;acall	WritePortA1
		acall	ReadPortA
					;MOV     A,DDH
		MOV     DatabusH,A
		SETB    DIOR            ;Negate DIOR
		mov	a,#000h
		acall	WritePortA
					;MOV     DDH,#000H
		
		RET

;=============================================================================
;                   Write Databus
;=============================================================================
Write:      NOP
		CLR     DIOW            ;Assert DIOW
		NOP
		SETB    DIOW            ;Negate DIOW
		RET

;----------------------------Delay-----------------------
DELAY:      MOV     R4,#00AH
DELAY1:     MOV     R2,#0A0H
D2:         MOV     R3,#000H
D3:         XCH     A,R5
                XCH     A,R5
                DJNZ    R3,D3
                DJNZ    R2,D2
                DJNZ    R4,DELAY1
                RET
;------------------------------------------------------
;----------------------------SDelay-----------------------
sDELAY:      MOV     R4,#002H
sDELAY1:     MOV     R2,#0A0H
sD2:         MOV     R3,#000H
sD3:         XCH     A,R5
                XCH     A,R5
                DJNZ    R3,sD3
                DJNZ    R2,sD2
                DJNZ    R4,sDELAY1
                RET
;------------------------------------------------------
org	SegTab
db	40h,79h,24h,30h,19h,12h,2h,78h,0h,10h	
KCODE0: 	db	1,2,3,FWDB
KCODE1: 	db	4,5,6,REWB
KCODE2: 	db	7,8,9,PAUSEB
KCODE3: 	db	ENTERB,0,PLAYB,STOPB
End